      function lip(zin)
      double precision zin
      double complex lip
      
      if(zin < 0d0) then
        lip = log(-zin) + (0d0,3.141592653589793d0)
      else
        lip = log(zin)
      endif
      end
      
      function lim(zin)
      double precision zin
      double complex lim
      
      if(zin < 0d0) then
        lim = log(-zin) - (0d0,3.141592653589793d0)
      else
        lim = log(zin)
      endif
      end
      
      function xlog(zin)
      double precision zin, xlog
      
      if(zin .eq. 0d0) then
        xlog = 0d0
      else
        xlog = zin*log(zin)
      endif
      end
      

      function li2(zin)
      double precision zin
      double complex li2
      double precision z, pow, add
      integer k
      
      if(zin > 0.5d0) then
        if(zin < 1d0) then
          li2 = 1.6449340668482262d0 - log(zin)*log(1d0-zin)
        elseif(zin > 1d0) then
          li2 = 1.6449340668482262d0 - log(zin)*
     +           (log(zin-1d0) + (0d0,3.141592653589793d0))
        else
          li2 = 1.6449340668482262d0
	  return
	endif
	z = 1d0-zin
	pow = -1d0
      else
        li2 = 0d0
	z = zin
        pow = 1d0
      endif
      if(z < -0.5d0) then
        li2 = li2 - pow * (0.5d0 * log(1d0-z)**2)
	z = -z/(1d0-z)
	pow = -pow
      endif
      do k=1,200
        pow = pow * z
	add = pow/k**2
	li2 = li2 + add
	if(abs(add) < abs(li2)*1d-16) return
      enddo
      write(0,*) 'dilog of', zin, ' does not converge!'
      stop      
      end
      
      
      function li3(zin)
      double precision zin
      double complex li3
      double complex lip
      double precision z, pow, add
      integer k

      if(abs(zin) > 1d0) then
        li3 = -(lip(-zin)**3 + 9.869604401089358d0*lip(-zin))/6d0
	z = 1d0/zin
      else
        li3 = 0d0
	z = zin
      endif
      pow = 1d0
      do k=1,1000
        pow = pow * z
	add = pow/k**3
	li3 = li3 + add
	if(abs(add) < abs(li3)*1d-16) return
      enddo
      write(0,*) 'trilog of', zin, ' does not converge!'
      stop      
      end

     
      subroutine cli2int(ndim, x, ncomp, ff)
      integer ndim, ncomp
      double precision x(*), ff(*)
      double complex z, res, li2z
      common /dilog/ li2z
      
      res = log(1-li2z*x(1))/x(1)      
      ff(1) = realpart(res)
      ff(2) = imagpart(res)
      end

      function cli2(zin)
      double complex zin
      double complex cli2
      double complex z, pow, add
      integer k
      
      external cli2int
      integer neval, nregions, fail
      double precision integral(2), error(2), prob(2)
      double complex li2z
      common /dilog/ li2z

      if(abs(imagpart(zin)) > abs(realpart(zin))*1d-8) then
        li2z = zin
        call cuhre(2, 2, cli2int, 1d-14, 1d-16, 0,0, 100000,
     +             1, nregions, neval, fail, integral, error, prob)
        if(fail .ne. 0) then
	  write(*,*) error(1), error(2)
          write(0,*) 'dilog of', zin, ' does not converge!'
          stop
	endif
        cli2 = -dcmplx(integral(1),integral(2))
	return
      endif
      if(realpart(zin) > 0.5d0) then
        if(realpart(zin) < 1d0) then
          cli2 = 1.6449340668482262d0 - log(zin)*log(1d0-zin)
        elseif(realpart(zin) > 1d0) then
          cli2 = 1.6449340668482262d0 - log(zin)*
     +           (log(zin-1d0) + (0d0,3.141592653589793d0))
        else
          cli2 = 1.6449340668482262d0
	  return
	endif
	z = 1d0-zin
	pow = -1d0
      else
        cli2 = 0d0
	z = zin
        pow = 1d0
      endif
      if(realpart(z) < -0.5d0) then
        cli2 = cli2 - pow * (0.5d0 * log(1d0-z)**2)
	z = -z/(1d0-z)
	pow = -pow
      endif
      do k=1,200
        pow = pow * z
	add = pow/k**2
	cli2 = cli2 + add
	if(abs(add) < abs(cli2)*1d-16) return
      enddo
      write(0,*) 'dilog of', zin, ' does not converge!'
      stop      
      end
      
      
      function f134(m1, m3, m4)
      double precision m1, m3, m4
      double complex f134
      double complex li2, cli2
      double precision xlog
      double precision x, y, m, lx, ly, lm, res
      double complex ls
      double precision pisqonsix
      parameter (pisqonsix=1.6449340668482264d0)
      
      if(m1 > m3 .and. m1 > m4) then
        x = m3/m1
	y = m4/m1
	m = m1
      elseif(m3 > m4) then
        x = m1/m3
	y = m4/m3
	m = m3
      else
        x = m1/m4
	y = m3/m4
	m = m4
      endif
      lm = log(m)
      if((x .eq. 0d0) .and. (y .eq. 0d0)) then
        f134 = m*(3.5d0 + 1.5d0*pisqonsix + lm*(lm-3d0))
	return
      endif
      if(x .eq. 0d0) then
        x = y
	y = 0d0
      endif
      if(y .eq. 0d0) then
        lx = log(x)
        res = 7d0 + pisqonsix*(3d0-x) + x*(7d0 + lx*(lx-6d0)) +
     +        2d0*lm*(lm-3d0)*(1d0+x) + 4d0*x*lx*lm - 
     +        2d0*lx*xlog(1d0-x) - (2d0-2d0*x)*li2(x)
        f134 = res * m/2d0
	return
      endif
      lx = log(x)
      ly = log(y)
      ls = sqrt(dcmplx(1d0+x*x+y*y-2d0*(x+y+x*y), 0d0))
      res = (7d0 + pisqonsix + 2d0*lm*(lm-3d0))*(1d0+x+y) +
     +       x*lx*(lx+4d0*lm-6d0) + y*ly*(ly+4d0*lm-6d0) +
     +       lx*ly*(x+y-1d0-ls) + 2d0*ls*(pisqonsix +
     +        log((1d0+x-y-ls)/2d0)*log((1d0-x+y-ls)/2d0) -
     +        cli2((1d0+x-y-ls)/2d0) - cli2((1d0-x+y-ls)/2d0))
      f134 = res * m/2d0
      end
      

#include "fdef.f"

      subroutine integrand(ndim, x, ncomp, ff)
      implicit double complex (t)
      integer ndim, ncomp
      double precision x(*), ff(*)
      
      double complex y(NVAR), z(NVAR), jgm(NVAR,NVAR), jg, res(NCOMP)
      double complex abbv(1000)
      integer i
      
#include "fvar.f"
      
#include "fint.f"
      do i=1,NCOMP
        ff(2*i-1) = realpart(res(i))
        ff(2*i)   = imagpart(res(i))
      enddo
      end


      Program fpint
      
      implicit double complex (t)

      external integrand
      double complex lip, lim, li2, li3, cli2, f134, ana(NCOMPA)
      double precision xlog, y
      
      integer npoints, neval, nregions, fail, i
      character intr
      double precision epsrel, epsabs!, xa(10), xb(10), xs(10)
      double precision integral(2*NCOMP), error(2*NCOMP), prob(2*NCOMP)
      real*4 time(2), timeold, timenew
      character*80 carg

#include "fvar.f"
#include "fvar2.f"

      call getarg(0,carg)
      i = len(carg)
      do while((carg(i:i) .ne. '/') .and. (i>1))
        i = i-1
      enddo
      epsabs = -1d0
      open(51, file=carg(1:i)//'runpar.sys', status='old', err=10)
      read(51,*,err=10,end=10) intr
      read(51,*,err=10,end=10) npoints
      read(51,*,err=10,end=10) epsrel
      read(51,*,err=10,end=10) epsabs
      close(51)
10    if(epsabs < 0) then
        write(0,*) "File runpar.sys not found or ill-formatted!"
	stop
      endif

#if NVAR==1
#define NVARC 2
#else
#define NVARC NVAR
#endif

#include "fana.f"
      timeold = etime(time)
      if(intr .eq. 'c') then
        call cuhre(NVARC, 2*NCOMP, integrand, epsrel, epsabs, 0,0,npoints,
     +             1, nregions, neval, fail, integral, error, prob)
      elseif(intr .eq. 'v') then
        call vegas(NVAR, 2*NCOMP, integrand, epsrel, epsabs, 0,0,npoints,
     +             20000, 10000, neval, fail, integral, error, prob)
      else
        write(0,*) "Unknown integration method '", intr, "'!"
	stop
      endif
      timenew = etime(time)
      do i=1,NCOMP
        write(*,*) complex(integral(2*i-1),integral(2*i)) + ana(i), 
     +	           complex(error(2*i-1), error(2*i)) 
      enddo
#if NCOMP<NCOMPA
      do i=NCOMP+1,NCOMPA
        if(ana(i) .ne. 0d0)  write(*,*) ana(i), complex(0d0,0d0)
      enddo
#endif
c      write(*,*) neval, prob(1), fail, timenew-timeold
      
      End
