TurboSimplify[expr_] := Module[{pos, subexprs, multiples, collist,colnames,ex2},
  pos = Position[expr, _Symbol];
  pos = (DeleteCases[#, 0] & ) /@ pos;
  subexprs = Extract[expr, pos];
  multiples = Select[Union[subexprs], (Count[subexprs, #] > 1)&];
  If[Length[multiples] === 0,
    Return[expr];
  ];
  multiples = Map[{#, Count[subexprs, #]-1} &, multiples];
  multiples = Sort[multiples, ((ByteCount[#1[[1]]]+1)*#[[2]] >
                                         (ByteCount[#2[[1]]]+1)*#[[2]]) &];
  multiples = Map[First, multiples];
  collist = Take[multiples, Floor[Length[multiples]/2]];
  colnames = Table[ToExpression["col" <> ToString[i]], {i, Length[collist]}];
  ex2 = expr /. Table[collist[[i]] -> colnames[[i]], {i, Length[collist]}];
  ex2 = Collect[ex2, colnames, Simplify];
  ex2 = ex2 /. Table[colnames[[i]] -> collist[[i]], {i, Length[collist]}];
  If[ByteCount[ex2] > ByteCount[expr],
    Return[expr],
    Return[ex2];
  ];
];
